#-------------------------------------------------------------------#
# ManageYamms.pl						    #
#-------------------------------------------------------------------#
# YaMMS 4 YaBB23						    #
# Version 0.5 beta						    #
# by Carsten Dalgaard						    #
#-------------------------------------------------------------------#
# Copyright: 2009 'Carsten Dalgaard' - All Rights Reserved	    #
# Released: December 30, 2008					    #
# e-mail: carsten.dalgaard@gmail.com				    #
#-------------------------------------------------------------------#
# Any redistribution of this script without the expressed written   #
# consent of 'Carsten Dalgaard' is strictly prohibited. Copying     #
# any	of the code contained within this script and claiming it as #
# your own is also prohibited.					    #
#-------------------------------------------------------------------#
# By using this script you agree to indemnify 'Carsten Dalgaard'    #
# from any liability that might arise from its use.		    #
#-------------------------------------------------------------------#
# You may not remove any of these header notices.		    #
#-------------------------------------------------------------------#
$manageyammsplver = 'YaBB 2.3 $Revision: 0.5 beta $';
if ($action eq 'detailedversion') { return 1; }

LoadLanguage("yamms");
LoadLanguage("MemberList");

sub ManageYamms {
	&is_admin_or_gmod;

	my ($onlinecolchecked, $locationcolchecked, $gendercolchecked, $pmcolchecked, $emailcolchecked, $wwwcolchecked, $msncolchecked, $gtalkcolchecked, $icqcolchecked, $yimcolchecked, $aimcolchecked, $skypecolchecked, $mapinmenuchecked, $mapguestschecked, $location_postsguestschecked, $location_postsgueststextchecked, $location_postschecked, $location_requiredchecked);
	my ($male_bchecked, $male_rchecked, $male_gchecked, $female_bchecked, $female_rchecked, $female_gchecked, $na_bchecked, $na_rchecked, $na_gchecked);
	if($onlinecol) { $onlinecolchecked = ' checked="checked"'; }
	if($locationcol) { $locationcolchecked = ' checked="checked"'; }
	if($gendercol) { $gendercolchecked = ' checked="checked"'; }
	if($pmcol) { $pmcolchecked = ' checked="checked"'; }
	if($emailcol) { $emailcolchecked = ' checked="checked"'; }
	if($wwwcol) { $wwwcolchecked = ' checked="checked"'; }
	if($msncol) { $msncolchecked = ' checked="checked"'; }
	if($gtalkcol) { $gtalkcolchecked = ' checked="checked"'; }
	if($icqcol) { $icqcolchecked = ' checked="checked"'; }
	if($yimcol) { $yimcolchecked = ' checked="checked"'; }
	if($aimcol) { $aimcolchecked = ' checked="checked"'; }
	if($skypecol) { $skypecolchecked = ' checked="checked"'; }
	if($mapinmenu) { $mapinmenuchecked = ' checked="checked"'; }
	if($mapguests && $mapinmenu) { $mapguestschecked = ' checked="checked"'; }
	elsif(!$mapinmenu) { $mapguestschecked = ' disabled="disabled"'; }

	if($location_postsguests) { $location_postsguestschecked = ' checked="checked"'; }
	if($location_postsgueststext) { $location_postsgueststextchecked = ' checked="checked"'; }
	if($location_posts) { $location_postschecked = ' checked="checked"'; }
	if($location_required) { $location_requiredchecked = ' checked="checked"'; }

	if($malepin eq "bpin") { $male_bchecked = ' checked="checked"'; }
	elsif($malepin eq "rpin") { $male_rchecked = ' checked="checked"'; }
	elsif($malepin eq "gpin") { $male_gchecked = ' checked="checked"'; }

	if($femalepin eq "bpin") { $female_bchecked = ' checked="checked"'; }
	elsif($femalepin eq "rpin") { $female_rchecked = ' checked="checked"'; }
	elsif($femalepin eq "gpin") { $female_gchecked = ' checked="checked"'; }

	if($napin eq "bpin") { $na_bchecked = ' checked="checked"'; }
	elsif($napin eq "rpin") { $na_rchecked = ' checked="checked"'; }
	elsif($napin eq "gpin") { $na_gchecked = ' checked="checked"'; }

	if(!-e ("$vardir/continent.txt") || !-e ("$vardir/country.txt")) {
		require "$sourcedir/Yamms.pl";
		&makemaps;
	}

	my ($cnmaps, $avmaps, $countr, @amlines);

	opendir(DIR, "$modimgdir/yamms/maps") || &fatal_error("$maptxt{'39'} ($modimgdir/yamms/maps)!");
	@mapcontents = readdir(DIR);
	closedir(DIR);

	fopen(FILE, "$vardir/continent.txt");
	@mlines = <FILE>;
	fclose(FILE);
	foreach $mline (@mlines) {
		chomp $mline;
		if( $mline =~ m~\A\s+\Z~ ) { next; }
		$omline = $mline;
		$omline =~ s/\_/ /g;
		$cnmaps .= qq~<option value="$mline">$omline</option>\n~;
	}
	foreach $tmpamline (@mapcontents) {
		chomp $tmpamline;
		($amline, $extension) = split(/\./, $tmpamline);
		if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i) {
			$notinuse = 1;
			foreach (@mlines) {
				chomp $_;
				if($_ eq $amline) { $notinuse = 0; }
			}
			if($notinuse) {
				$aomline = $amline;
				$aomline =~ s/\_/ /g;
				$avmaps .= qq~<option value="$amline">$aomline</option>\n~;
			}
		}
	}
	$avmaps .= qq~<option value=""></option>\n~;

	opendir(DIR, "$modimgdir/yamms/flag") || &fatal_error("$maptxt{'39'} ($modimgdir/yamms/flag)!");
	@flcontents = readdir(DIR);
	closedir(DIR);

	fopen(FILE, "$vardir/country.txt");
	my @clines = <FILE>;
	fclose(FILE);
	foreach $cline (@clines) {
		chomp $cline;
		if( $cline =~ m~\A\s+\Z~ ) { next; }
		$ocline = $cline;
		$ocline =~ s/\_/ /g;
		$countr .= qq~<option value="$cline">$ocline</option>\n~;
	}
	foreach $tmpafline (@flcontents) {
		chomp $tmpafline;
		($afline, $fextension) = split(/\./, $tmpafline);
		if ($fextension =~ /gif/i || $fextension =~ /jpg/i || $fextension =~ /jpeg/i || $fextension =~ /png/i) {
			$fnotinuse = 1;
			foreach (@clines) {
				chomp $_;
				if($_ eq $afline) { $fnotinuse = 0; }
			}
			if($fnotinuse) {
				$aofline = $afline;
				$aofline =~ s/\_/ /g;
				$avcountr .= qq~<option value="$afline">$aofline</option>\n~;
			}
		}
	}
	$avcountr .= qq~<option value=""></option>\n~;

$yymain .= qq~
<form action="$adminurl?action=manageyamms1" method="post">
<div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
<table width="100%" cellspacing="1" cellpadding="4">
	<tr>
		<td align="left" class="titlebg">
		<img src="$imagesdir/preferences.gif" alt="" border="0" /><b>$maptxt{'70'}</b>
		</td>
	</tr>
	<tr>
		<td align="left" class="catbg">
		<img src="$imagesdir/guest.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'66'}
		</td>
	</tr>
	<tr>
		<td class="windowbg2">
			<div class="setting_cell" style="height: 25px;"><b>$maptxt{'67'}:</b></div>
			<div class="setting_cell2" style="height: 25px;">&nbsp;</div>

			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/online_off.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'46'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="onlinecol" style="border: 0; padding: 0; margin: 0;" $onlinecolchecked /></div>

			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/location_off.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'03'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="locationcol" style="border: 0; padding: 0; margin: 0;" $locationcolchecked /></div>

			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/gender_off.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'44'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="gendercol" style="border: 0; padding: 0; margin: 0;" $gendercolchecked /></div>
			<br />
			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/pm_off.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'71'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="pmcol" style="border: 0; padding: 0; margin: 0;" $pmcolchecked /></div>
			<br />
			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/email_off.gif" alt="" border="0" style="vertical-align: middle;" /> $ml_txt{'307'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="emailcol" style="border: 0; padding: 0; margin: 0;" $emailcolchecked /></div>
			<br />
			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/www_off.gif" alt="" border="0" style="vertical-align: middle;" /> $ml_txt{'96'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="wwwcol" style="border: 0; padding: 0; margin: 0;" $wwwcolchecked /></div>
			<br />
			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/msn_off.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'40'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="msncol" style="border: 0; padding: 0; margin: 0;" $msncolchecked /></div>
			<br />
			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/gtalk_off.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'55'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="gtalkcol" style="border: 0; padding: 0; margin: 0;" $gtalkcolchecked /></div>
			<br />
			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/icq_off.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'41'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="icqcol" style="border: 0; padding: 0; margin: 0;" $icqcolchecked /></div>
			<br />
			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/yim_off.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'42'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="yimcol" style="border: 0; padding: 0; margin: 0;" $yimcolchecked /></div>
			<br />
			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/aim_off.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'43'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="aimcol" style="border: 0; padding: 0; margin: 0;" $aimcolchecked /></div>
			<br />
			<div class="setting_cell" style="font-size: 10px; height: 25px;"><img src="$modimgurl/yamms/skype_off.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'68'} $maptxt{'16'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="skypecol" style="border: 0; padding: 0; margin: 0;" $skypecolchecked /></div>
			<br />
		</td>
	</tr>
	<tr>
		<td align="left" class="catbg">
		<img src="$modimgurl/yamms/map.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'64'}
		</td>
	</tr>
	<tr>
		<td class="windowbg2">
			<div class="setting_cell" style="font-size: 10px; height: 25px;">$maptxt{'63'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="mapinmenu" id="mapinmenu" onclick="chekaccess(this.id, 'mapguests')" $mapinmenuchecked /></div>
			<br />

			<div class="setting_cell" style="font-size: 10px; height: 25px;">$maptxt{'77'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="mapguests" id="mapguests" $mapguestschecked /></div>
			<br />

			<div class="setting_cell" style="font-size: 10px; height: 25px;">$maptxt{'86'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;">
			<input type="checkbox" name="location_postsguests" id="location_postsguests" $location_postsguestschecked /> <label for="location_postsguests">$maptxt{'53'}</label> &nbsp;
			<input type="checkbox" name="location_postsgueststext" id="location_postsgueststext" $location_postsgueststextchecked /> <label for="location_postsgueststext">$maptxt{'52'}</label>
			</div>
			<br />

			<div class="setting_cell" style="font-size: 10px; height: 25px;">$maptxt{'72'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="location_posts" id="location_posts" $location_postschecked /></div>

			<div class="setting_cell" style="font-size: 10px; height: 25px;">$maptxt{'87'}</div>
			<div class="setting_cell2" style="font-size: 10px; height: 25px;"><input type="checkbox" name="location_required" id="location_required" $location_requiredchecked /></div>
		</td>
	</tr>
	<tr>
		<td class="windowbg2">
			<div class="setting_cell"><b>$maptxt{'73'}</b></div>
			<div class="setting_cell2">
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><img src="$modimgurl/yamms/bpin.gif" border="0" alt="" /></div>
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><img src="$modimgurl/yamms/rpin.gif" border="0" alt="" /></div>
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><img src="$modimgurl/yamms/gpin.gif" border="0" alt="" /></div>
			</div>
			<br />
			<div class="setting_cell" style="text-align: right;"><span class="small"><b>$maptxt{'74'}:</b>&nbsp;</span></div>
			<div class="setting_cell2">
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><input type="radio" name="malepin" value="bpin" class="windowbg2" style="border: 0px;"$male_bchecked /></div>
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><input type="radio" name="malepin" value="rpin" class="windowbg2" style="border: 0px;"$male_rchecked /></div>
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><input type="radio" name="malepin" value="gpin" class="windowbg2" style="border: 0px;"$male_gchecked /></div>
			</div>
			<br />
			<div class="setting_cell" style="text-align: right;"><span class="small"><b>$maptxt{'75'}:</b>&nbsp;</span></div>
			<div class="setting_cell2">
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><input type="radio" name="femalepin" value="bpin" class="windowbg2" style="border: 0px;"$female_bchecked /></div>
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><input type="radio" name="femalepin" value="rpin" class="windowbg2" style="border: 0px;"$female_rchecked /></div>
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><input type="radio" name="femalepin" value="gpin" class="windowbg2" style="border: 0px;"$female_gchecked /></div>
			</div>
			<br />
			<div class="setting_cell" style="text-align: right;"><span class="small"><b>$maptxt{'76'}:</b>&nbsp;</span></div>
			<div class="setting_cell2">
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><input type="radio" name="napin" value="bpin" class="windowbg2" style="border: 0px;"$na_bchecked /></div>
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><input type="radio" name="napin" value="rpin" class="windowbg2" style="border: 0px;"$na_rchecked /></div>
				<div style="float: left; width: 25px; height: 20px; text-align: center; vertical-align: middle;"><input type="radio" name="napin" value="gpin" class="windowbg2" style="border: 0px;"$na_gchecked /></div>
			</div>
			<br />
		</td>
	</tr>
	<tr>
		<td align="center" class="catbg">
			<input type="submit" value="$maptxt{'06'}" />
		</td>
	</tr>
</table>
</div>
</form>
<a name="mapanch">&nbsp;</a>
<br />
<div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
<table width="100%" cellspacing="1" cellpadding="4">
	<tr>
		<td class="titlebg">
		<img src="$imagesdir/preferences.gif" alt="" border="0" /><b>$maptxt{'56'}</b>
		</td>
	</tr>
	<tr>
		<td class="windowbg2"><br />
		$maptxt{'62'}<br /><br />
		</td>
	</tr>
	<tr>
		<td align="left" class="catbg">
			<span class="small">$maptxt{'57'}:</span>
		</td>
	</tr>
	<tr>
		<td class="windowbg" align="center">
		<form action="$adminurl?action=managemap2#mapanch" method="post">
		<select name="availmaps" id="availmaps" size="10" style="font-size: 12px; width: 250px; margin: 4px;" multiple="multiple">$avmaps</select>
		<select name="maps" id="maps" size="10" style="font-size: 12px; width: 250px; margin: 4px;" multiple="multiple">$cnmaps</select><br />
		<input type="submit" name="mapmove" id="mapmove" value="$maptxt{'61'}" style="width: 190px;" />
		<input type="submit" name="mapback" id="mapback" value="$maptxt{'59'}" />
		<input type="submit" name="mapsave" id="mapsave" value="$maptxt{'60'}" style="width: 190px;" />
		</form>
		</td>
	</tr>
	<tr>
		<td align="left" class="catbg">
			<span class="small">$maptxt{'58'}:</span>
		</td>
	</tr>
	<tr>
		<td class="windowbg" align="center">
		<form action="$adminurl?action=managemap3#mapanch" method="post">
		<select name="availcountry" id="availcountry" size="10" style="font-size: 12px; width: 250px; margin: 4px;" multiple="multiple">$avcountr</select>
		<select name="country" id="country" size="10" style="font-size: 12px; width: 250px; margin: 4px;" multiple="multiple">$countr</select><br />
		<input type="submit" name="countrymove" id="countrymove" value="$maptxt{'61'}" style="width: 190px;" />
		<input type="submit" name="countryback" id="countryback" value="$maptxt{'59'}" />
		<input type="submit" name="countrysave" id="countrysave" value="$maptxt{'60'}" style="width: 190px;" />
		</form>
		</td>
	</tr>
</table>
</div>

<script language="JavaScript1.2" type="text/javascript">
function chekaccess(masterele, slaveele) {
	if (document.getElementById(masterele).checked) {
		document.getElementById(slaveele).disabled = false;
	}
	else{
		document.getElementById(slaveele).disabled = true;
		document.getElementById(slaveele).checked = false;
	}
}
//-->
</script>

~;

	$yytitle = $maptxt{'56'};
	$action_area = "manageyamms";
	&AdminTemplate;
	exit;
}

sub ManageYamms1 {
	&is_admin_or_gmod;

	my @onoff = qw/onlinecol locationcol gendercol pmcol emailcol wwwcol msncol gtalkcol icqcol yimcol aimcol skypecol mapinmenu mapguests location_posts location_postsguests location_postsgueststext location_required/;
	my $fi;
	map { $fi = lc $_; ${$_} = $FORM{$fi} eq 'on' ? 1 : 0; } @onoff;

	$malepin = $FORM{'malepin'} || 'bpin';
	$femalepin = $FORM{'femalepin'} || 'rpin';
	$napin = $FORM{'napin'} || 'gpin';

	my $filler  = q~                                                                               ~;
	my $setfile = << "EOF";
###############################################################################
# Member List Settings                                                        #
###############################################################################

\$onlinecol = $onlinecol;				# Set to 1 to allow members to view/hide the on-line columns.
\$locationcol = $locationcol;				# Set to 1 to allow members to view/hide the location columns.
\$gendercol = $gendercol;				# Set to 1 to allow members to view/hide the gender columns.
\$pmcol = $pmcol;					# Set to 1 to allow members to view/hide the Personal Message columns.
\$emailcol = $emailcol;					# Set to 1 to allow members to view/hide the e-mail columns.
\$wwwcol = $wwwcol;					# Set to 1 to allow members to view/hide the homepage columns.
\$msncol = $msncol;					# Set to 1 to allow members to view/hide the MSN columns.
\$gtalkcol = $gtalkcol;					# Set to 1 to allow members to view/hide the Google Talk columns.
\$icqcol = $icqcol;					# Set to 1 to allow members to view/hide the ICQ columns.
\$yimcol = $yimcol;					# Set to 1 to allow members to view/hide the YIM columns.
\$aimcol = $aimcol;					# Set to 1 to allow members to view/hide the AIM columns.
\$skypecol = $skypecol;					# Set to 1 to allow members to view/hide the Skype columns.

###############################################################################
# Member Map Settings                                                         #
###############################################################################

\$mapinmenu = $mapinmenu;				# Set to 1 to add Member Map to main menu.
\$mapguests = $mapguests;				# Set to 1 to enable guest access to Member Map.
\$location_postsguests = $location_postsguests;		# Set to 1 to let guests view location flag in posts.
\$location_postsgueststext = $location_postsgueststext;	# Set to 1 to let guests view location text in posts.
\$location_posts = $location_posts;			# Set to 1 to let members set view/hide location in posts.
\$location_required = $location_required;		# Set to 1 to make location required at registration.
\$malepin = "$malepin";
\$femalepin = "$femalepin";
\$napin = "$napin";

1;
EOF

	$setfile =~ s~(.+\;)\s+(\#.+$)~$1 . substr( $filler, 0, (70-(length $1)) ) . $2 ~gem;
	$setfile =~ s~(.{64,}\;)\s+(\#.+$)~$1 . "\n   " . $2~gem;
	$setfile =~ s~^\s\s\s+(\#.+$)~substr( $filler, 0, 70 ) . $1~gem;

	fopen(FILE, ">$vardir/YammsSettings.txt");
	print FILE $setfile;
	fclose(FILE);

	$yySetLocation = qq~$adminurl?action=manageyamms~;
	&redirectexit;
}

sub ManageMap2 {
	&is_admin_or_gmod;
	if($FORM{'mapsave'}) {
		fopen(FILE, "$vardir/continent.txt");
		@usemaps = <FILE>;
		fclose(FILE);

		@maps = split(/\, /, $FORM{'maps'});

		fopen(FILE, ">$vardir/continent.txt", 1);
		foreach $map (@usemaps) {
			$saveit = 1;
			chomp $map;
			foreach $delmap (@maps) {
				chomp $delmap;
				if($map eq $delmap) { $saveit = 0; }
			}
			if($saveit) { print FILE "$map\n"; }
		}
		fclose(FILE);
	}
	elsif($FORM{'mapmove'}) {
		@maps = split(/\, /, $FORM{'availmaps'});

		fopen(FILE, "$vardir/continent.txt");
		@tmpusemaps = <FILE>;
		fclose(FILE);
		chomp @tmpusemaps;

		push(@tmpusemaps, @maps);
		@usemaps = sort @tmpusemaps;

		fopen(FILE, ">$vardir/continent.txt", 1);
		foreach $map (@usemaps) {
			$map =~ s/ /\_/g;
			print FILE "$map\n";
		}
		fclose(FILE);
	}
	else {
		unlink("$vardir/continent.txt");
	}

	$yySetLocation = qq~$adminurl?action=manageyamms~;
	&redirectexit;
}

sub ManageMap3 {
	&is_admin_or_gmod;
	if($FORM{'countrysave'}) {
		fopen(FILE, "$vardir/country.txt");
		@usecountry = <FILE>;
		fclose(FILE);

		@country = split(/\, /, $FORM{'country'});

		fopen(FILE, ">$vardir/country.txt", 1);
		foreach $mcountry (@usecountry) {
			$saveit = 1;
			chomp $mcountry;
			foreach $delcountry (@country) {
				chomp $delcountry;
				if($mcountry eq $delcountry) { $saveit = 0; }
			}
			if($saveit) { print FILE "$mcountry\n"; }
		}
		fclose(FILE);
	}
	elsif($FORM{'countrymove'}) {
		@country = split(/\, /, $FORM{'availcountry'});

		fopen(FILE, "$vardir/country.txt");
		@tmpusecountry = <FILE>;
		fclose(FILE);
		chomp @tmpusecountry;

		push(@tmpusecountry, @country);
		@usecountry = sort @tmpusecountry;

		fopen(FILE, ">$vardir/country.txt", 1);
		foreach $mcountry (@usecountry) {
			$mcountry =~ s/ /\_/g;
			print FILE "$mcountry\n";
		}
		fclose(FILE);
	}
	else {
		unlink("$vardir/country.txt");
	}

	$yySetLocation = qq~$adminurl?action=manageyamms~;
	&redirectexit;
}

1;